import type { JSXChildren, QRL, JSXNode } from "@builder.io/qwik";
export type BaseClassNames = {
    td?: string;
    tcol?: {
        [heading: string]: string;
    };
};
export type THeadClassNames = BaseClassNames & {
    thead?: string;
    th?: string;
};
export type TBodyClassNames = BaseClassNames & {
    tbody?: string;
    tr?: string;
};
export type TableClassNames = TBodyClassNames & THeadClassNames & {
    table?: string;
};
export type THeadProps = {
    headings: Array<string>;
    customHeadings: undefined | {
        [heading: string]: string;
    };
    classNames: THeadClassNames;
};
export type CellData = {
    [key: string]: JSXChildren;
};
export type TBodyProps = {
    data: Array<CellData>;
    headings: Array<string>;
    classNames: TBodyClassNames;
    element?: {
        [key: string]: QRL<(record: CellData, param: string) => JSXNode | string>;
    };
};
export type TableData = {
    tData: Array<CellData>;
    element?: {
        [key: string]: QRL<(record: CellData, param: string) => JSXNode | string>;
    };
    tableOptions?: {
        customHeadings?: {
            [heading: string]: string;
        };
        classNames?: TableClassNames;
    };
};
