"use strict";
const qwik = require("@builder.io/qwik");
const param2Text = /* @__PURE__ */ qwik.inlinedQrl((param) => {
  if (param === "id")
    return "ID";
  let returnVal = "";
  const camelCaseWords = param.replace(/([A-Z])/g, " $1");
  const result = camelCaseWords.charAt(0).toUpperCase() + camelCaseWords.slice(1);
  const snakeCaseWords = result.split(/_|-/);
  snakeCaseWords.forEach((word, index) => returnVal += word.charAt(0).toUpperCase() + word.slice(1) + (index === snakeCaseWords.length - 1 ? "" : " "));
  return returnVal;
}, "param2Text_agI06SZVpyY");
const TableHeader = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxQ("thead", null, {
    class: qwik._fnSignal((p0) => p0.classNames.thead, [
      props
    ], "p0.classNames.thead")
  }, /* @__PURE__ */ qwik._jsxQ("tr", null, null, props.headings.map((heading) => /* @__PURE__ */ qwik._jsxQ("th", {
    class: `${props.classNames.th} ${props.classNames.td}${props.classNames.tcol?.[heading] ? " " + props.classNames.tcol?.[heading] : ""}`
  }, null, props.customHeadings?.[heading] || param2Text(heading), 1, heading)), 1, null), 1, "Lj_0");
}, "TableHeader_component_oOJ0YwcCTJc"));
const TableBody = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  return /* @__PURE__ */ qwik._jsxQ("tbody", null, {
    class: qwik._fnSignal((p0) => p0.classNames.tbody, [
      props
    ], "p0.classNames.tbody")
  }, props.data.map((record, index) => {
    return /* @__PURE__ */ qwik._jsxQ("tr", null, {
      class: qwik._fnSignal((p0) => p0.classNames.tr, [
        props
      ], "p0.classNames.tr")
    }, props.headings.map((heading) => /* @__PURE__ */ qwik._jsxQ("td", {
      class: `${props.classNames.td}${props.classNames.tcol?.[heading] ? " " + props.classNames.tcol?.[heading] : ""}`
    }, null, props.element?.[heading]?.(record, heading) || record[heading], 1, heading)), 1, index);
  }), 1, "Oe_0");
}, "TableBody_component_KzgCLC9bSzA"));
const defaultClassNames = {
  table: "table",
  thead: "table-head",
  th: "table-heading",
  tbody: "table-body",
  tr: "table-row",
  td: "table-cell"
};
const TableLoader = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik.useStore({
    param: "",
    order: 0
  });
  const headings = Object.keys(props.tData[0]);
  const theadClassNames = {
    thead: props.tableOptions?.classNames?.thead || defaultClassNames.thead,
    th: props.tableOptions?.classNames?.th || defaultClassNames.th,
    td: props.tableOptions?.classNames?.td || defaultClassNames.td,
    tcol: props.tableOptions?.classNames?.tcol || void 0
  };
  const tbodyClassNames = {
    tbody: props.tableOptions?.classNames?.tbody || defaultClassNames.tbody,
    tr: props.tableOptions?.classNames?.tr || defaultClassNames.tr,
    td: props.tableOptions?.classNames?.td || defaultClassNames.td,
    tcol: props.tableOptions?.classNames?.tcol || void 0
  };
  return /* @__PURE__ */ qwik._jsxQ("table", {
    class: props.tableOptions?.classNames?.table || defaultClassNames.table
  }, null, [
    /* @__PURE__ */ qwik._jsxC(TableHeader, {
      headings,
      get customHeadings() {
        return props.tableOptions?.customHeadings;
      },
      classNames: theadClassNames,
      [qwik._IMMUTABLE]: {
        customHeadings: qwik._fnSignal((p0) => p0.tableOptions?.customHeadings, [
          props
        ], "p0.tableOptions?.customHeadings")
      }
    }, 3, "h1_0"),
    /* @__PURE__ */ qwik._jsxC(TableBody, {
      get data() {
        return props.tData;
      },
      headings,
      classNames: tbodyClassNames,
      get element() {
        return props.element;
      },
      [qwik._IMMUTABLE]: {
        data: qwik._fnSignal((p0) => p0.tData, [
          props
        ], "p0.tData"),
        element: qwik._fnSignal((p0) => p0.element, [
          props
        ], "p0.element")
      }
    }, 3, "h1_1")
  ], 1, "h1_2");
}, "TableLoader_component_hOQfsSkMQGw"));
module.exports = TableLoader;
